﻿@using System.Security.Claims
@{
    ViewData["Title"] = "Regulatory Documents";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
    var additionalRoles = ViewBag.additionalRoles;
    bool hasAdviserRole = !string.IsNullOrEmpty(additionalRoles) ? additionalRoles.Contains(Roles.Adviser) : false;
    bool hasComplianceRole = !string.IsNullOrEmpty(additionalRoles) ? additionalRoles.Contains(AdminRoleEnum.Compliance.ToString()) : false;
    bool isValidAdv2B = ViewBag.isValidDateOfBirth && ViewBag.isValidContactInfo && ViewBag.hasRIA;

    var tooltipHtml = "Pending Items To Complete";
    if (!isValidAdv2B)
        tooltipHtml += "<ul>";
    if (!ViewBag.isValidDateOfBirth)
        tooltipHtml += @"<li>Date of Birth</li>";
    if (!ViewBag.isValidContactInfo)
        tooltipHtml += @"<li>Contact Information</li>";
    if (!ViewBag.hasRIA)
        tooltipHtml += @"<li>Select RIA</li >";
    if (!isValidAdv2B)
        tooltipHtml += "</ul>";
}
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1 @(!isValidAdv2B ?"disabled-div" :"")">
                        @if (role == Roles.Client || role == Roles.Adviser || hasAdviserRole)
                        {
                            <a href="@(isValidAdv2B ? Url.RouteUrl("adviser/adv-2b", new { token = ViewBag.token }) :"javascript:")" class="btn btn-sm btn-maroon mb-5 font-weight-bold @(!isValidAdv2B ? "disabled" : "")" target="@(isValidAdv2B ?"_blank" :"")" id="btn-adv2b"><i class="far fa-eye"></i>ADV 2B</a>
                            @if (!isValidAdv2B)
                            {
                                <span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="@tooltipHtml" data-placement="right" role="button" style="top:-8px">
                                    <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                    <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                    <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                </span>
                            }
                        }
                    </div>
                    <div class="align-self-center">
                        @if (hasComplianceRole)
                        {
                            <button class="btn btn-sm btn-primary btn-upload-document btn-add mr-10 font-size-h6"><i class="fas fa-upload"></i>Upload</button>
                        }
                    </div>
                    @if (role != Roles.Client)
                    {
                        <div class="align-self-center">
                            <a onclick="goBackAdviser('@area')" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Go Back">
                                <i class="fas fa-arrow-left"></i>
                            </a>
                        </div>
                    }
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="datatable datatable-bordered datatable-sticky" id="regulatory_documents"></div>
        </div>
    </div>
</div>
<div class="modal" id="RegulatoryDocumentUploadModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        var tz = new Date().getTimezoneOffset();
        var href = $("#btn-adv2b").attr("href");
        $("#btn-adv2b").attr("href", `${href}&tz=${tz}`);
        var firmId = $("#hdnFirmId").val();
        $(document).on("click", ".btn-upload-document", function() {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`adviser/home/regulatorydocumentmodal?guid=${guid}&firmId=${firmId}`, "RegulatoryDocumentUploadModal", null, function() {
                KTApp.unblockPage();
                $("#RegulatoryDocumentUploadModal").modal({ backdrop: 'static' });
            });
        });
        var ktDataTablOptions = ktDataTableDefaultConfigOptions;
        ktDataTablOptions.source = `adviser/home/fetchregulatorydocuments?firmId=${firmId}`;
        var datatable = $('#regulatory_documents').KTDatatable({
            data: ktDataTablOptions,
            columns: [
                { field: 'id', title: '#', width: 30 },
                { field: 'fileName', title: 'File Name', width: 430 },
                {
                    field: 'extension', title: 'File Type', sortable: false,  textAlign: 'center', width: 90,
                    template: function(row) {
                        var extension = row.extension;
                        row.fileName = row.fileName.replace("'", "/");
                        var type = extension.includes("doc") ? "word" : extension.includes("xls") ? "excel" : extension.includes("csv") ? "csv" : extension.includes("ppt") ? "powerpoint" : extension.includes("pdf") ? "pdf" : row.contentType.includes("image") ? "image" : row.contentType.includes("audio") ? "audio" : row.contentType.includes("video") ? "video" : row.contentType.includes("text") ? "alt" : "";
                        var color = extension.includes("doc") ? "295497" : extension.includes("xls") || extension.includes("csv") ? "1f7244" : extension.includes("ppt") ? "d14424" : extension.includes("pdf") ? "cb0606" : row.contentType.includes("image") ? "26b99a" : row.contentType.includes("audio") ? "8950FC" : row.contentType.includes("video") ? "F64E60" : row.contentType.includes("text") ? "3699FF" : "008080";
                        var knownHtml = `<i class="fas fa-file${type.length > 0 ? "-" : ""}${type}" style="color:#${color};font-size: 30px;" data-toggle="tooltip" data-title="${extension.toUpperCase()}" id="icon-${row.id}"></i>`;
                        var unknownHtml = `<span class="fa-stack fa-1x" style="font-size:1.2em !important" data-toggle="tooltip" data-title="${extension.toUpperCase()}" id="icon-${row.id}">
                                                        <i class="fa fa-file fa-stack-2x" style="color:#${color}"></i>
                                                          <span class="fa fa-stack-1x">
                                                              <span style="font-size:10px;color:white;font-family: 'Poppins';font-weight: normal;">
                                                                  ${extension.toUpperCase()}
                                                              </span>
                                                        </span>
                                                    </span>	`;
                        return `<a href="javascript:" onclick="clientFileDownload('documents/regulatory', '${row.fileName}',0,${row.id})">
                                            ${type.length > 0 ? knownHtml : unknownHtml}
                                            <i class="fas fa-arrow-down animated faa-falling ml-2 text-primary d-none" id="loader-${row.id}"></i>
                                        </a>`;
                    }
                },
                {
                    field: 'fileSize', title: 'File Size', width: 80,
                    template: function(row) {
                        return humanFileSize(row.fileSize);
                    }
                },
                {
                    field: 'uploadedDate', title: 'Uploaded Date', sortable: 'desc', width: 125,
                    template: function(row) {
                        return getDataTableDateWithHtml(row.uploadedDate)
                    },
                },
            ],
        })
        $(document).on("click", ".btn-regulatory-delete", function(e) {
            e.preventDefault()
            var cur = this;
            var swalOptions = confimationSwalOptions;
            Swal.fire(swalOptions)
                .then(function(result) {
                    if (result.value) {
                        var guid = $(cur).attr("data-guid");
                        deleteRecord(`adviser/home/deleteRegulatory?guid=${guid}`, function() {
                            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                            datatable.reload();
                            setTimeout(function() { KTApp.unblockPage(); }, 1000);
                        });
                    }
                });
        });
        $(".topbar").css("pointer-events", "none");
    </script>
}